/**
 * Copyright (c) 2015 Impact Mobile Inc.
 */
package com.test;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

import javax.ejb.Stateless;
import javax.inject.Inject;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.core.Response;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@Path( "/test" )
@Stateless
public class RestService
{
    private static final Logger log = LoggerFactory.getLogger( RestService.class );

    @Inject
    QueueProducer queueProducer;

    @GET
    @Path( "/generate/{total}" )
    public Response postJms( @PathParam( "total" ) int total)
    {
        if ( total <= 0 )
        {
            return Response.ok().build();
        }
        final int batchSize = 10000;

        for ( int msgsSent = 0; msgsSent < total; )
        {

            List<JmsMessage> msgs = new ArrayList<>( total );

            for ( int x = 0; x < batchSize && msgsSent < total; x++, msgsSent++ )
            {
                JmsMessage msg = new JmsMessage();
                msg.setMessage( UUID.randomUUID().toString() );
                msgs.add( msg );
            }

            queueProducer.sendJmsMessages( msgs );
            log.info( "Queued {} messages ({} total)", msgs.size(), msgsSent );
        }

        return Response.ok().build();
    }

}
